{%- macro invalidate(invalidated_at, job_status, maestro_id, type, option) -%}
    <!-- Invalidate button; disable and change label and color when already invalidated -->
    {% if not invalidated_at %}
        <!-- Show Invalidate button only for workflows or completed steps -->
        {% if job_status == 'JobStatus.COMPLETED' or type == "workflow" %}
            <button
                hx-on:click="htmx.toggleClass('#invalidate-confirm_{{ maestro_id }}', 'hidden')"
                type="button"
                id="invalidate-button_{{ maestro_id }}"
                class="bg-ellayellow-darker hover:bg-ellayellow w-24 cursor-pointer select-none rounded-md px-2 py-1 text-sm text-gray-700"
                name="invalidate"
                title="Invalidate"
            >
                Invalidate
            </button>
        {% else %}
            <div class="inline-flex items-center font-sans text-sm text-gray-400">
                <img
                    src="/static/information_sign_gray.svg"
                    alt="Information sign"
                    class="mr-3 h-7 w-7"
                />
                <div>Step has no outputs to invalidate</div>
            </div>
        {% endif %}
    {% elif option == "propagate" %}
        <button
            hx-on:click="htmx.toggleClass('#invalidate-confirm_{{ maestro_id }}', 'hidden')"
            type="button"
            id="invalidate-button_{{ maestro_id }}"
            class="bg-ellapurple hover:bg-ellapurple-lighter w-24 cursor-pointer select-none rounded-md px-2 py-1 text-sm text-gray-700"
            name="invalidated"
            title="Already invalidated - push to propagate"
        >
            Invalidated
        </button>
    {% elif option == "nopropagate" %}
        <!-- Disable when nothing to propagate -->
        <button
            type="button"
            id="invalidate-button_{{ maestro_id }}"
            class="w-24 select-none rounded-md bg-gray-200 px-2 py-1 text-sm text-gray-400"
            name="invalidate"
            title="Already invalidated - nothing to do"
            disabled
        >
            Invalidated
        </button>
    {% endif %}
    <div id="invalidate-confirm_{{ maestro_id }}" class="hidden whitespace-normal">
        {% if type == "workflow" %}
            <!-- Show warning with counts of workflows, steps and artefacts that will be invalidated -->
            <!-- grid is needed here as Firefox won't heed place-self-end otherwise -->
            <div class="grid">
                <!-- Empty div to place on new line -->
                <div></div>
                <div
                    class="border-ellared-darker bg-ellared-light mt-2 flex w-24 items-center justify-center place-self-end rounded-lg border py-1 lg:w-[12.5rem]"
                    id="invalidate-warning_{{ maestro_id }}"
                    hx-get="api/v1/invalidate/count/workflow/{{ maestro_id }}/false"
                    hx-trigger="load"
                >
                    <!-- Warning goes here -->
                </div>
            </div>
        {% endif %}

        {% if option == "propagate" %}
            <!-- Propagate: Also allow for already invalidated workflow step or artefact. -->
            <div class="mt-3"></div>
            <input
                type="radio"
                class="peer/propagate hidden"
                name="propagate"
                id="propagate-{{ maestro_id }}"
            />
            <label
                for="propagate-{{ maestro_id }}"
                class="bg-ellablue hover:bg-ellablue-darker peer-checked/propagate:shadow-ellablue-darkest peer-checked/propagate:bg-ellablue-darkest cursor-pointer select-none rounded-l-md py-1 pl-3 pr-2 text-center text-sm text-white peer-checked/propagate:shadow-inner"
                title="Propagate invalidation downstream"
            >
                Propagate
            </label>
            {% if not invalidated_at %}
                <input
                    type="radio"
                    class="peer/nopropagate hidden"
                    name="propagate"
                    id="nopropagate-{{ maestro_id }}"
                />
                <label
                    for="nopropagate-{{ maestro_id }}"
                    class="bg-ellablue hover:bg-ellablue-darker peer-checked/nopropagate:shadow-ellablue-darkest peer-checked/nopropagate:bg-ellablue-darkest border-ellablue-darker cursor-pointer select-none whitespace-nowrap rounded-r-md border-l px-3 py-1 text-center text-sm text-white peer-checked/nopropagate:shadow-inner"
                    title="Invalidate this only"
                >
                    This only
                </label>
            {% else %}
                <!--  Disable if already invalidated -->
                <input
                    type="radio"
                    class="peer/nopropagate hidden"
                    name="propagate"
                    id="nopropagate-{{ maestro_id }}"
                    disabled
                />
                <label
                    for="nopropagate-{{ maestro_id }}"
                    class="border-ellablue-darker cursor-pointer select-none rounded-r-md border-l bg-gray-200 px-3 py-1 text-center text-sm text-gray-400"
                    title="Already invalidated. Use other option to propagate downstream."
                >
                    This only
                </label>
            {% endif %}
            <!-- empty div to place confirm/cancel on new line-->
            <div></div>
            <!-- Show warning with counts of steps and artefacts that will be invalidated -->
            {% if type == "workflow_step" %}
                <div
                    class="border-ellared-darker bg-ellared-light mt-3 hidden items-center justify-center place-self-end rounded-lg border py-1 peer-checked/propagate:flex"
                    hx-get="api/v1/invalidate/count/workflow_step/{{ maestro_id }}/true"
                    hx-trigger="load"
                >
                    <!-- Warning goes here -->
                </div>
                <div
                    class="border-ellared-darker bg-ellared-light mt-3 hidden items-center justify-center place-self-end rounded-lg border py-1 peer-checked/nopropagate:flex"
                    hx-get="api/v1/invalidate/count/workflow_step/{{ maestro_id }}/false"
                    hx-trigger="load"
                >
                    <!-- Warning goes here -->
                </div>
            {% elif type == "artefact" %}
                <div
                    class="border-ellared-darker bg-ellared-light mt-3 hidden items-center justify-center place-self-end rounded-lg border py-1 peer-checked/propagate:flex"
                    hx-get="api/v1/invalidate/count/artefact/{{ maestro_id }}/true"
                    hx-trigger="load"
                >
                    <!-- Warning goes here -->
                </div>
                <div
                    class="border-ellared-darker bg-ellared-light mt-3 hidden items-center justify-center place-self-end rounded-lg border py-1 peer-checked/nopropagate:flex"
                    hx-get="api/v1/invalidate/count/artefact/{{ maestro_id }}/false"
                    hx-trigger="load"
                >
                    <!-- Warning goes here -->
                </div>
            {% endif %}
            <!--  Confirm with chosen parameters or cancel; hide dialogue -->
            <button
                hx-on:click="htmx.toggleClass('#invalidate-confirm_{{ maestro_id }}', 'hidden')"
                hx-put="/api/v1/invalidate/{{ type }}"
                hx-vals="js:{maestro_id: '{{ maestro_id }}', propagate: document.getElementById('propagate-{{ maestro_id }}').checked}"
                hx-target="#invalidate-button_{{ maestro_id }}"
                hx-swap="outerHTML"
                type="button"
                class="bg-ellared-darkest hover:bg-ellared-darker mt-2 hidden w-24 rounded-md px-2 py-1 text-sm text-white peer-checked/nopropagate:inline-block peer-checked/propagate:inline-block"
                name="confirm"
                title="Confirm invalidation with chosen parameters. Warning: This removes artefacts from further use."
            >
                Confirm
            </button>
            <button
                hx-on:click="htmx.toggleClass('#invalidate-confirm_{{ maestro_id }}', 'hidden')"
                type="button"
                class="mt-2 hidden w-24 rounded-md bg-gray-300 px-2 py-1 text-sm text-gray-700 hover:bg-gray-400 hover:text-white peer-checked/nopropagate:inline-block peer-checked/propagate:inline-block lg:ml-1"
                name="cancel"
                title="Cancel"
            >
                Cancel
            </button>
        {% elif option == "nopropagate" %}
            <div class="lg:flex lg:w-[12.5rem]">
                <!-- No propagation for input artefacts, only confirm/cancel -->
                <!-- empty div to place confirm/cancel on new line-->
                <div></div>
                <!--  Confirm or cancel; hide dialogue -->
                <button
                    hx-on:click="htmx.toggleClass('#invalidate-confirm_{{ maestro_id }}', 'hidden')"
                    hx-put="/api/v1/invalidate/{{ type }}"
                    hx-target="#invalidate-button_{{ maestro_id }}"
                    hx-swap="outerHTML"
                    hx-vals="js:{maestro_id: '{{ maestro_id }}', propagate: false}"
                    type="button"
                    class="bg-ellared-darkest hover:bg-ellared-darker mt-2 inline-block w-24 rounded-md px-2 py-1 text-sm text-white"
                    name="confirm"
                    title="Confirm invalidation. Use with caution!"
                >
                    Confirm
                </button>
                <button
                    hx-on:click="htmx.toggleClass('#invalidate-confirm_{{ maestro_id }}', 'hidden')"
                    type="button"
                    class="mt-2 inline-block w-24 rounded-md bg-gray-300 px-2 py-1 text-sm text-gray-700 hover:bg-gray-400 hover:text-white lg:ml-1"
                    name="cancel"
                    title="Cancel"
                >
                    Cancel
                </button>
            </div>
        {% endif %}
    </div>
{%- endmacro -%}

{%- macro reorder(invalidated_at, maestro_id, type, job_status) -%}
    <!-- 
        Reorder button; disable if step is not invalidated, cancelled or failed.
        Note: "| string" is needed for job_details
    -->
    {%
        if invalidated_at
        or job_status in ('JobStatus.FAILED', 'JobStatus.CANCELLED')
        or job_status | string in ('JobStatus.FAILED', 'JobStatus.CANCELLED')
    %}
        <button
            hx-on:click="htmx.toggleClass('#reorder_{{ maestro_id }}', 'hidden')"
            type="button"
            id="reorder-button_{{ maestro_id }}"
            class="bg-ellayellow-darker hover:bg-ellayellow w-24 cursor-pointer select-none rounded-md px-2 py-1 text-sm text-gray-700"
            name="reorder"
            title="Reorder this worflow step"
        >
            Reorder
        </button>
    {% else %}
        <div class="inline-flex items-center font-sans text-sm text-gray-400">
            <img
                src="/static/information_sign_gray.svg"
                alt="Information sign"
                class="mr-3 h-7 w-7"
            />
            <div>Nothing to reorder</div>
        </div>
    {% endif %}

    <div class="my-2"></div>
    <!-- Confirm or cancel reorder -->
    <div id="reorder_{{ maestro_id }}" class="hidden">
        <button
            hx-put="/api/v1/reorder/job/{{ maestro_id }}"
            hx-on:click="htmx.toggleClass('#reorder_{{ maestro_id }}', 'hidden')"
            hx-target="#reorder-button_{{ maestro_id }}"
            hx-swap="outerHTML"
            type="button"
            class="bg-ellared-darkest hover:bg-ellared-darker w-24 rounded-md px-2 py-1 text-sm text-white"
            name="confirm"
            title="Confirm: Reorder this workflow step"
        >
            Confirm
        </button>
        <button
            hx-on:click="htmx.toggleClass('#reorder_{{ maestro_id }}', 'hidden')"
            type="button"
            class="ml-1 w-24 rounded-md bg-gray-300 px-2 py-1 text-sm text-gray-700 hover:bg-gray-400 hover:text-white"
            name="cancel"
            title="Cancel"
        >
            Cancel
        </button>
    </div>
{%- endmacro -%}

{%- macro abort(maestro_id) -%}
    <!-- Abort button for pending/halted steps -->
    <div class="flex-shrink-0">
        <button
            hx-on:click="htmx.toggleClass('#abort-confirm_{{ maestro_id }}', 'hidden')"
            type="button"
            id="abort-button_{{ maestro_id }}"
            class="bg-ellayellow-darker hover:bg-ellayellow w-24 cursor-pointer select-none rounded-md px-2 py-1 text-sm text-gray-700"
            name="abort"
            title="Abort this worflow step"
        >
            Abort
        </button>
        <!-- Confirm or cancel abort -->
        <div id="abort-confirm_{{ maestro_id }}" class="hidden whitespace-normal">
            <!-- empty div to place confirm/cancel on new line-->
            <div></div>
            <button
                hx-put="/api/v1/cancel/job/{{ maestro_id }}"
                hx-on:click="htmx.toggleClass('#abort-confirm_{{ maestro_id }}', 'hidden')"
                hx-target="#abort-button_{{ maestro_id }}"
                hx-swap="outerHTML"
                type="button"
                class="bg-ellared-darkest hover:bg-ellared-darker mt-2 w-24 rounded-md px-2 py-1 text-sm text-white"
                name="confirm"
                title="Confirm: Abort this workflow step"
            >
                Confirm
            </button>
            <button
                hx-on:click="htmx.toggleClass('#abort-confirm_{{ maestro_id }}', 'hidden'); htmx.toggleClass('#details-button_{{ maestro_id }}', 'hidden')"
                type="button"
                class="mt-2 w-24 rounded-md bg-gray-300 px-2 py-1 text-sm text-gray-700 hover:bg-gray-400 hover:text-white lg:ml-1"
                name="cancel"
                title="Do not abort this workflow step"
            >
                Cancel
            </button>
        </div>
    </div>
{%- endmacro -%}

{%- macro resume(maestro_id, job_status) -%}
    <!-- Resume button; disable if job is not halted -->
    {% if job_status == 'JobStatus.HALTED' %}
        <button
            hx-on:click="htmx.toggleClass('#resume_{{ maestro_id }}', 'hidden')"
            type="button"
            id="resume-button_{{ maestro_id }}"
            class="bg-ellayellow-darker hover:bg-ellayellow w-24 cursor-pointer select-none rounded-md px-2 py-1 text-sm text-gray-700"
            name="resume"
            title="Continue this workflow"
        >
            Continue
        </button>
    {% else %}
        <div class="inline-flex items-center font-sans text-sm text-gray-400">
            <img
                src="/static/information_sign_gray.svg"
                alt="Information sign"
                class="mr-3 h-7 w-7"
            />
            <div>Step has nothing to resume</div>
        </div>
    {% endif %}

    <div class="my-2"></div>
    <!-- Confirm or cancel resume -->
    <div id="resume_{{ maestro_id }}" class="hidden">
        <button
            hx-put="/api/v1/resume/job/{{ maestro_id }}"
            hx-on:click="htmx.toggleClass('#resume_{{ maestro_id }}', 'hidden')"
            hx-target="#resume-button_{{ maestro_id }}"
            hx-swap="outerHTML"
            type="button"
            class="bg-ellared-darkest hover:bg-ellared-darker w-24 rounded-md px-2 py-1 text-sm text-white"
            name="confirm"
            title="Confirm: Continue this workflow"
        >
            Confirm
        </button>
        <button
            hx-on:click="htmx.toggleClass('#resume_{{ maestro_id }}', 'hidden')"
            type="button"
            class="ml-1 w-24 rounded-md bg-gray-300 px-2 py-1 text-sm text-gray-700 hover:bg-gray-400 hover:text-white"
            name="cancel"
            title="Cancel"
        >
            Cancel
        </button>
    </div>
{%- endmacro -%}
